_http_errors_in_content = [
	"Empty reply from server",
	"Unknown SSL protocol error in connection",
	"Received HTTP code 502 from proxy after CONNECT",
	"Received HTTP code 403 from proxy after CONNECT"
];
_http_fatal_errors = [
	"Connection refused",
	"Could not resolve proxy",
	"Received invalid version in initial SOCKS5 response"
];
function httpClientCustom_ContentContainsError(content){
	content = content.trim();
	return _http_errors_in_content.indexOf(content) > -1;
};
function httpClientCustom_IsFatalError(error){
	error = error.trim();
	return _http_fatal_errors.indexOf(error) > -1;
};
function httpClientCustom_SwitchClient(ClientVersion){
	if(ClientVersion){
		if(ClientVersion=="main"){
			_switch_http_client_main();
		}else{
			_switch_http_client_internal();
		};
	};
};
function httpClientCustom_Proxy(proxy_text, proxy_type, proxy_login, proxy_password, client_version){
	httpClientCustom_SwitchClient(client_version);

	var proxy = proxy_parse(proxy_text);
	if(proxy_type!="auto"){
		proxy["IsHttp"] = proxy_type=="http";
	};
	var login = proxy_login;
	var password = proxy_password;
	if(login.length > 0 && password.length > 0){
		proxy["name"] = login;
		proxy["password"] = password;
	};
	
	http_client_set_proxy(proxy["server"], proxy["Port"], proxy["IsHttp"], proxy["name"], proxy["password"]);
};
function httpClientCustom_Content(encoding, client_version){
	httpClientCustom_SwitchClient(client_version);

	if(encoding=="json"){
		return JSON.parse(http_client_encoded_content("auto"));
	}else{
		return http_client_encoded_content(encoding);
	};
};
function httpClientCustom_Get(){
	var value = _function_argument("Value");
	var headers = _function_argument("Headers");
	var method = _function_argument("Method");
	var redirect = _function_argument("Redirect");
	var timeout = _function_argument("Timeout")*1000;
	var maximum_failes = _function_argument("MaximumFailes");
	var client_version = _function_argument("ClientVersion");
	
	httpClientCustom_SwitchClient(client_version);
	
	_do(function(){
		var cycle_index = _iterator();
		
		_call(function(){
			_on_fail(function(){
				VAR_LAST_ERROR = _result();
				VAR_ERROR_ID = ScriptWorker.GetCurrentAction();
				VAR_WAS_ERROR = false;
				_break(1,true);
			});
			CYCLES.Current().RemoveLabel("function");
			
			_if_else(redirect, function(){
				general_timeout_next(timeout);
				http_client_get2(value,{method:(method),headers:(headers)})!
			}, function(){
				general_timeout_next(timeout);
				http_client_get_no_redirect2(value,{method:(method),headers:(headers)})!
			})!
		},null)!
		
		var content = http_client_encoded_content();
		
		_if_else(VAR_WAS_ERROR || httpClientCustom_ContentContainsError(content), function(){
			if(cycle_index>=maximum_failes || httpClientCustom_IsFatalError(VAR_LAST_ERROR)){
				if(!VAR_WAS_ERROR && httpClientCustom_ContentContainsError(content)){
					fail(content)
				}else{
					fail(VAR_LAST_ERROR)
				}
			}
			sleep(1000)!
		}, function(){
			_break("function")
		})!
	})!
};
function httpClientCustom_Post(){
	var value = _function_argument("Value");
	var params = _function_argument("Params");
	var content_type = _function_argument("ContentType");
	var encoding =  _function_argument("Encoding");
	var method = _function_argument("Method");
	var headers = _function_argument("Headers");
	var maximum_failes = _function_argument("MaximumFailes");
	var redirect = _function_argument("Redirect");
	var timeout = _function_argument("Timeout")*1000;
	var client_version = _function_argument("ClientVersion");
	
	httpClientCustom_SwitchClient(client_version);
	
	_do(function(){
		var cycle_index = _iterator();
		
		_call(function(){
			_on_fail(function(){
				VAR_LAST_ERROR = _result();
				VAR_ERROR_ID = ScriptWorker.GetCurrentAction();
				VAR_WAS_ERROR = false;
				_break(1,true);
			});
			CYCLES.Current().RemoveLabel("function");
			
			_if_else(redirect, function(){
				general_timeout_next(timeout);
				http_client_post(value, params, {"content-type":content_type, "encoding":encoding, "method":method, "headers":headers})!
			}, function(){
				general_timeout_next(timeout);
				http_client_post_no_redirect(value, params, {"content-type":content_type, "encoding":encoding, "method":method, "headers":headers})!
			})!
		},null)!
		
		var content = http_client_encoded_content();
		
		_if_else(VAR_WAS_ERROR || httpClientCustom_ContentContainsError(content), function(){
			if(cycle_index>=maximum_failes || httpClientCustom_IsFatalError(VAR_LAST_ERROR)){
				if(!VAR_WAS_ERROR && httpClientCustom_ContentContainsError(content)){
					fail(content)
				}else{
					fail(VAR_LAST_ERROR)
				}
			}
			sleep(1000)!
		}, function(){
			_break("function")
		})!
	})!
};
function httpClientCustom_Download(){
	var value = _function_argument("Value");
	var file = _function_argument("File");
	var timeout = _function_argument("Timeout")*1000;
	var maximum_failes = _function_argument("MaximumFailes");
	var client_version = _function_argument("ClientVersion");
	
	httpClientCustom_SwitchClient(client_version);
	
	_do(function(){
		var cycle_index = _iterator();
		
		_call(function(){
			_on_fail(function(){
				VAR_LAST_ERROR = _result();
				VAR_ERROR_ID = ScriptWorker.GetCurrentAction();
				VAR_WAS_ERROR = false;
				_break(1,true);
			});
			CYCLES.Current().RemoveLabel("function");
			
			general_timeout_next(timeout);
			http_client_download(value, file)!
		},null)!
		
		_if_else(VAR_WAS_ERROR, function(){
			if(cycle_index>=maximum_failes || httpClientCustom_IsFatalError(VAR_LAST_ERROR)){
				fail(VAR_LAST_ERROR)
			}
			sleep(1000)!
		}, function(){
			_break("function")
		})!
	})!
};